]> git.ipfire.org Git - ipfire-2.x.git/blame - make.sh
UPnP-Tools kompiliert und getestet -> GEIL :D
[ipfire-2.x.git] / make.sh
CommitLineData
df5e82b3 1#!/bin/bash
df5e82b3
MT
2############################################################################
3# #
f8e5510c 4# This file is part of the IPFire Firewall. #
df5e82b3 5# #
f8e5510c 6# IPFire is free software; you can redistribute it and/or modify #
df5e82b3
MT
7# it under the terms of the GNU General Public License as published by #
8# the Free Software Foundation; either version 2 of the License, or #
9# (at your option) any later version. #
10# #
f8e5510c 11# IPFire is distributed in the hope that it will be useful, #
df5e82b3
MT
12# but WITHOUT ANY WARRANTY; without even the implied warranty of #
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14# GNU General Public License for more details. #
15# #
16# You should have received a copy of the GNU General Public License #
f8e5510c 17# along with IPFire; if not, write to the Free Software #
df5e82b3
MT
18# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19# #
15679d9f 20# Copyright (C) 2006 IPFire-Team <info@ipfire.eu>. #
df5e82b3
MT
21# #
22############################################################################
df5e82b3
MT
23#
24
15679d9f
MT
25NAME="IPFire" # Software name
26SNAME="ipfire" # Short name
5bd13f01 27VERSION="2.0b" # Version number
8e2e5cf3 28SLOGAN="www.ipfire.org" # Software slogan
15679d9f
MT
29CONFIG_ROOT=/var/ipfire # Configuration rootdir
30NICE=10 # Nice level
857d9bf2 31MAX_RETRIES=1 # prefetch/check loop
15679d9f
MT
32KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
33MACHINE=`uname -m`
34SVN_REVISION=`svn info | grep Revision | cut -c 11-`
35
03ad5f93
MT
36IPFVER="full" # Which version should be compiled? (full|light|voice)
37
38# Set an information about the build number
15679d9f
MT
39if [ -e ./.svn ]; then
40 FIREBUILD=`cat .svn/entries |sed -n 's/^[ \t]*revision=\"// p' | sed -n 's/\".*$// p'`
41fi
42
43# Debian specific settings
44if [ ! -e /etc/debian_version ]; then
df5e82b3 45 FULLPATH=`which $0`
15679d9f 46else
df5e82b3
MT
47 if [ -x /usr/bin/realpath ]; then
48 FULLPATH=`/usr/bin/realpath $0`
49 else
50 echo "ERROR: Need to do apt-get install realpath"
51 exit 1
52 fi
15679d9f 53fi
df5e82b3 54
15679d9f
MT
55PWD=`pwd`
56BASENAME=`basename $0`
57BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
58LOGFILE=$BASEDIR/log/_build.preparation.log
59export BASEDIR LOGFILE
60DIR_CHK=$BASEDIR/cache/check
61mkdir $BASEDIR/log/ 2>/dev/null
df5e82b3 62
15679d9f
MT
63# Include funtions
64. tools/make-functions
df5e82b3 65
15679d9f
MT
66if [ -f .config ]; then
67 . .config
68else
6b8cff41
MT
69 echo -e "${BOLD}No configuration found!${NORMAL}"
70 echo -ne "Do you want to create one (y/N)?"
71 read CREATE_CONFIG
72 echo ""
73 if [ "$CREATE_CONFIG" == "y" ]; then
74 make_config
75 fi
15679d9f 76fi
df5e82b3
MT
77
78prepareenv() {
79 ############################################################################
80 # #
81 # Are we running the right shell? #
82 # #
83 ############################################################################
84 if [ ! "$BASH" ]; then
85 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
86 fi
87
88 if [ -z "${BASH_VERSION}" ]; then
89 exiterror "Not running BASH shell."
90 fi
91
92
93 ############################################################################
94 # #
95 # Trap on emergency exit #
96 # #
97 ############################################################################
98 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
99
100
101 ############################################################################
102 # #
103 # Resetting our nice level #
104 # #
105 ############################################################################
9b0ff0a0 106 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
df5e82b3
MT
107 renice $NICE $$ > /dev/null
108 if [ `nice` != "$NICE" ]; then
15679d9f 109 beautify message FAIL
df5e82b3 110 exiterror "Failed to set correct nice level"
15679d9f
MT
111 else
112 beautify message DONE
df5e82b3
MT
113 fi
114
15679d9f 115
df5e82b3
MT
116 ############################################################################
117 # #
118 # Checking if running as root user #
119 # #
120 ############################################################################
9b0ff0a0 121 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
df5e82b3 122 if [ `id -u` != 0 ]; then
15679d9f 123 beautify message FAIL
df5e82b3 124 exiterror "Not building as root"
15679d9f
MT
125 else
126 beautify message DONE
df5e82b3
MT
127 fi
128
129
130 ############################################################################
131 # #
132 # Checking for necessary temporary space #
133 # #
134 ############################################################################
9b0ff0a0 135 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
df5e82b3
MT
136 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
137 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
41921bd9 138 if (( 2048000 > $BASE_ASPACE )); then
df5e82b3 139 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
41921bd9 140 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
15679d9f 141 beautify message FAIL
41921bd9 142 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
df5e82b3 143 fi
15679d9f
MT
144 else
145 beautify message DONE
df5e82b3
MT
146 fi
147
148 ############################################################################
149 # #
150 # Building Linux From Scratch system #
151 # #
152 ############################################################################
df5e82b3
MT
153 # Set umask
154 umask 022
155
156 # Set LFS Directory
157 LFS=$BASEDIR/build
158
159 # Check /tools symlink
160 if [ -h /tools ]; then
161 rm -f /tools
162 fi
163 if [ ! -a /tools ]; then
164 ln -s $BASEDIR/build/tools /
165 fi
166 if [ ! -h /tools ]; then
167 exiterror "Could not create /tools symbolic link."
168 fi
169
170 # Setup environment
171 set +h
172 LC_ALL=POSIX
fcb5057d 173 MAKETUNING="-j12"
dd714b8a 174 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
df5e82b3
MT
175 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
176
177 # Make some extra directories
178 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
90d372c4 179 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
df5e82b3 180 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
90d372c4
MT
181 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
182
183 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
184 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
df5e82b3
MT
185
186 # Make all sources and proc available under lfs build
90d372c4 187 mount --bind /dev $BASEDIR/build/dev
857d9bf2
MT
188 mount --bind /dev/pts $BASEDIR/build/dev/pts
189 mount --bind /dev/shm $BASEDIR/build/dev/shm
190 mount --bind /proc $BASEDIR/build/proc
191 mount --bind /sys $BASEDIR/build/sys
df5e82b3
MT
192 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
193 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
194 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
195 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
196 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
197 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
198 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
199 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
200 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
201
119ee469 202 # This is a temporary hack!!!
6b8cff41
MT
203 if [ ! -f /tools/bin/hostname ]; then
204 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
205 fi
119ee469 206
df5e82b3
MT
207 # Run LFS static binary creation scripts one by one
208 export CCACHE_DIR=$BASEDIR/ccache
209 export CCACHE_HASHDIR=1
210
211 # Remove pre-install list of installed files in case user erase some files before rebuild
212 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
213}
214
df5e82b3
MT
215buildtoolchain() {
216 LOGFILE="$BASEDIR/log/_build.toolchain.log"
217 export LOGFILE
df5e82b3
MT
218 ORG_PATH=$PATH
219 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
220 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
221 lfsmake1 ccache
15679d9f
MT
222 lfsmake1 binutils PASS=1
223 lfsmake1 gcc PASS=1
df5e82b3 224 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
dd714b8a
MT
225 lfsmake1 linux-libc-header
226 lfsmake1 glibc
9b0ff0a0 227 lfsmake1 cleanup-toolchain PASS=1
df5e82b3
MT
228 lfsmake1 tcl
229 lfsmake1 expect
df5e82b3 230 lfsmake1 dejagnu
15679d9f
MT
231 lfsmake1 gcc PASS=2
232 lfsmake1 binutils PASS=2
dd714b8a
MT
233 lfsmake1 ncurses
234 lfsmake1 bash
df5e82b3 235 lfsmake1 bzip2
dd714b8a 236 lfsmake1 coreutils
df5e82b3
MT
237 lfsmake1 diffutils
238 lfsmake1 findutils
dd714b8a 239 lfsmake1 gawk
df5e82b3 240 lfsmake1 gettext
dd714b8a
MT
241 lfsmake1 grep
242 lfsmake1 gzip
243 lfsmake1 m4
244 lfsmake1 make
df5e82b3 245 lfsmake1 patch
dd714b8a
MT
246 lfsmake1 perl
247 lfsmake1 sed
df5e82b3
MT
248 lfsmake1 tar
249 lfsmake1 texinfo
df5e82b3 250 lfsmake1 util-linux
9b0ff0a0 251 lfsmake1 cleanup-toolchain PASS=2
df5e82b3
MT
252 export PATH=$ORG_PATH
253}
254
255buildbase() {
256 LOGFILE="$BASEDIR/log/_build.base.log"
257 export LOGFILE
df5e82b3 258 lfsmake2 stage2
9b0ff0a0 259 lfsmake2 linux-libc-header
df5e82b3
MT
260 lfsmake2 man-pages
261 lfsmake2 glibc
9b0ff0a0 262 lfsmake2 cleanup-toolchain PASS=3
df5e82b3
MT
263 lfsmake2 binutils
264 lfsmake2 gcc
9b0ff0a0 265 lfsmake2 berkeley
df5e82b3 266 lfsmake2 coreutils
df5e82b3 267 lfsmake2 iana-etc
df5e82b3
MT
268 lfsmake2 m4
269 lfsmake2 bison
9b0ff0a0
MT
270 lfsmake2 ncurses
271 lfsmake2 procps
df5e82b3 272 lfsmake2 sed
9b0ff0a0 273 lfsmake2 libtool
df5e82b3 274 lfsmake2 perl
9b0ff0a0
MT
275 lfsmake2 readline
276 lfsmake2 zlib
df5e82b3
MT
277 lfsmake2 autoconf
278 lfsmake2 automake
279 lfsmake2 bash
df5e82b3
MT
280 lfsmake2 bzip2
281 lfsmake2 diffutils
df5e82b3 282 lfsmake2 e2fsprogs
65998e0a 283 lfsmake2 ed
9b0ff0a0
MT
284 lfsmake2 file
285 lfsmake2 findutils
286 lfsmake2 flex
15679d9f 287 lfsmake2 grub
9b0ff0a0
MT
288 lfsmake2 gawk
289 lfsmake2 gettext
290 lfsmake2 grep
291 lfsmake2 groff
df5e82b3 292 lfsmake2 gzip
9b0ff0a0
MT
293 lfsmake2 inetutils
294 lfsmake2 iproute2
295 lfsmake2 kbd
296 lfsmake2 less
df5e82b3 297 lfsmake2 make
9b0ff0a0
MT
298 lfsmake2 man
299 lfsmake2 mktemp
df5e82b3 300 lfsmake2 modutils
65998e0a 301 lfsmake2 net-tools
df5e82b3 302 lfsmake2 patch
df5e82b3
MT
303 lfsmake2 psmisc
304 lfsmake2 shadow
305 lfsmake2 sysklogd
306 lfsmake2 sysvinit
307 lfsmake2 tar
90d372c4
MT
308 lfsmake2 texinfo
309 lfsmake2 udev
df5e82b3 310 lfsmake2 util-linux
90d372c4 311 lfsmake2 vim
df5e82b3
MT
312}
313
15679d9f 314buildipfire() {
907cd036 315 LOGFILE="$BASEDIR/log/_build.ipfire.log"
df5e82b3 316 export LOGFILE
15679d9f
MT
317 ipfiremake configroot
318 ipfiremake dhcp
319 ipfiremake dhcpcd
320 ipfiremake libusb
321 ipfiremake libpcap
a10ae6cc 322 ipfiremake linux-atm
15679d9f
MT
323 ipfiremake ppp
324 ipfiremake rp-pppoe
325 ipfiremake unzip
3a1019f6 326 ipfiremake linux SMP=1
552b817b 327 ipfiremake ipp2p SMP=1
05207d69
MT
328 ipfiremake fcdsl SMP=1
329 ipfiremake fcdsl2 SMP=1
330 ipfiremake fcdslsl SMP=1
331 ipfiremake fcdslusb SMP=1
332 ipfiremake fcdslslusb SMP=1
333 ipfiremake fcpci SMP=1
a10ae6cc 334# ipfiremake promise-sata-300-tx SMP=1
dd001658 335 ipfiremake zaptel SMP=1
c3e36980 336 ipfiremake linux
552b817b 337 ipfiremake ipp2p
05207d69
MT
338 ipfiremake fcdsl
339 ipfiremake fcdsl2
340 ipfiremake fcdslsl
341 ipfiremake fcdslusb
342 ipfiremake fcdslslusb
343 ipfiremake fcpci
f59e1e88 344# ipfiremake promise-sata-300-tx
119f6ad3 345 ipfiremake zaptel
15679d9f
MT
346 ipfiremake expat
347 ipfiremake gdbm
348 ipfiremake gmp
c8ead4a5 349 ipfiremake pam
15679d9f
MT
350 ipfiremake openssl
351 ipfiremake python
352 ipfiremake libnet
ddac6087 353 ipfiremake libjpeg
15679d9f
MT
354 ipfiremake libpng
355 ipfiremake libtiff
15679d9f
MT
356 ipfiremake lcms
357 ipfiremake libmng
358 ipfiremake freetype
fd3e7da0 359 ipfiremake libart
15679d9f
MT
360 ipfiremake gd
361 ipfiremake popt
411afd1f 362 ipfiremake pcre
15679d9f
MT
363 ipfiremake slang
364 ipfiremake newt
fd3e7da0 365 ipfiremake libcap
15679d9f 366 ipfiremake pciutils
15679d9f 367 ipfiremake libxml2
6b8cff41 368 ipfiremake BerkeleyDB
15679d9f 369 ipfiremake mysql
411afd1f 370 ipfiremake cyrus-sasl
15679d9f
MT
371 ipfiremake openldap
372 ipfiremake apache2
373 ipfiremake php
a10ae6cc 374 ipfiremake apache2 PASS=C
15679d9f
MT
375 ipfiremake arping
376 ipfiremake beep
377 ipfiremake bind
378 ipfiremake capi4k-utils
379 ipfiremake cdrtools
380 ipfiremake dnsmasq
381 ipfiremake dosfstools
72d80898 382 ipfiremake reiserfsprogs
26ec9513 383 ipfiremake squashfstools
15679d9f
MT
384 ipfiremake ethtool
385 ipfiremake ez-ipupdate
386 ipfiremake fcron
7b9e5f10 387 ipfiremake GD
15679d9f
MT
388 ipfiremake gnupg
389 ipfiremake hdparm
390 ipfiremake ibod
391 ipfiremake initscripts
392 ipfiremake iptables
490256d5 393 ipfiremake libupnp
552b817b 394 ipfiremake ipp2p IPT=1
490256d5 395 ipfiremake linux-igd
15679d9f
MT
396 ipfiremake ipac-ng
397 ipfiremake ipaddr
15679d9f 398 ipfiremake iptstate
fd3e7da0 399 ipfiremake iputils
15679d9f 400 ipfiremake l7-protocols
a10ae6cc 401 ipfiremake isapnptools
fe6d84cb 402# ipfiremake isdn4k-utils # What about mISDN???
72d80898 403 ipfiremake kudzu
15679d9f
MT
404 ipfiremake logrotate
405 ipfiremake logwatch
15679d9f
MT
406 ipfiremake misc-progs
407 ipfiremake mtools
408 ipfiremake nano
409 ipfiremake nash
410 ipfiremake nasm
411 ipfiremake URI
412 ipfiremake HTML-Tagset
413 ipfiremake HTML-Parser
414 ipfiremake Compress-Zlib
415 ipfiremake Digest
416 ipfiremake Digest-SHA1
417 ipfiremake Digest-HMAC
418 ipfiremake libwww-perl
419 ipfiremake Net-DNS
420 ipfiremake Net-IPv4Addr
421 ipfiremake Net_SSLeay
422 ipfiremake IO-Stringy
423 ipfiremake Unix-Syslog
424 ipfiremake Mail-Tools
425 ipfiremake MIME-Tools
426 ipfiremake Net-Server
427 ipfiremake Convert-TNEF
428 ipfiremake Convert-UUlib
429 ipfiremake Archive-Tar
430 ipfiremake Archive-Zip
431 ipfiremake Text-Tabs+Wrap
432 ipfiremake Locale-Country
433 ipfiremake GeoIP
434 ipfiremake fwhits
435 ipfiremake noip_updater
436 ipfiremake ntp
437 ipfiremake oinkmaster
438 ipfiremake openssh
439 ipfiremake openswan
440 ipfiremake pptpclient
441 ipfiremake rrdtool
442 ipfiremake setserial
443 ipfiremake setup
444 ipfiremake snort
445 ipfiremake squid
446 ipfiremake squid-graph
447 ipfiremake squidguard
6f00de0d 448 ipfiremake tcpdump
15679d9f
MT
449 ipfiremake traceroute
450 ipfiremake vlan
451 ipfiremake wireless
452 ipfiremake libsafe
453 ipfiremake 3c5x9setup
454 ipfiremake pakfire
15679d9f
MT
455 ipfiremake java
456 ipfiremake bootsplash
457 ipfiremake spandsp
458 ipfiremake lzo
459 ipfiremake openvpn
460 ipfiremake pkg-config
461 ipfiremake glib
15679d9f 462 ipfiremake pammysql
15679d9f
MT
463 ipfiremake xinetd
464 ipfiremake ghostscript
465 ipfiremake cups
466 ipfiremake samba
467 ipfiremake sudo
468 ipfiremake mc
469 ipfiremake wget
470 ipfiremake wput
471 ipfiremake bridge-utils
472 ipfiremake screen
473 ipfiremake hddtemp
474 ipfiremake smartmontools
475 ipfiremake htop
476 ipfiremake lynx
477 ipfiremake postfix
478 ipfiremake procmail
479 ipfiremake fetchmail
480 ipfiremake cyrusimap
481 ipfiremake webcyradm
482 ipfiremake mailx
483 ipfiremake clamav
484 ipfiremake razor
485 ipfiremake spamassassin
fd3e7da0 486 ipfiremake amavisd
15679d9f 487 ipfiremake stund
15679d9f 488 ipfiremake libpri
119f6ad3 489# ipfiremake bristuff
15679d9f
MT
490 ipfiremake asterisk
491 ipfiremake mpg123
492 ipfiremake libmad
493 ipfiremake libogg
494 ipfiremake libvorbis
495 ipfiremake lame
496 ipfiremake xvid
497 ipfiremake mpeg2dec
498 ipfiremake ffmpeg
499 ipfiremake sox
500 ipfiremake gnump3d
501 ipfiremake videolan
502 ipfiremake applejuice
503 ipfiremake ocaml
504 ipfiremake mldonkey
505 ipfiremake ntop
506 ipfiremake rsync
507 ipfiremake tcpwrapper
508 ipfiremake portmap
509 ipfiremake nfs
510 ipfiremake nmap
511 ipfiremake mbmon
512 ipfiremake iftop
513 ipfiremake ncftp
514 ipfiremake cftp
515 ipfiremake etherwake
516 ipfiremake ethereal
517 ipfiremake tftp-hpa
518 ipfiremake iptraf
519 ipfiremake nagios
520 ipfiremake yasuc
df5e82b3
MT
521}
522
523buildinstaller() {
524 # Run installer scripts one by one
525 LOGFILE="$BASEDIR/log/_build.installer.log"
526 export LOGFILE
0afc6d83 527 ipfiremake syslinux
fd0763dc 528 ipfiremake memtest
bc9f0c12
MT
529 installmake linux-libc-header
530 installmake binutils
531 ipfiremake uClibc PASS=1
532 ipfiremake gcc INST=1
533 installmake uClibc PASS=2
534 installmake gcc INST=2
535 installmake uClibc PASS=3
df5e82b3 536 installmake busybox
c66941dd 537 installmake udev
33634aa8
MT
538 installmake slang
539 installmake newt
72d80898 540 installmake gettext
33634aa8
MT
541 installmake kbd
542 installmake popt
33634aa8 543 installmake sysvinit
df5e82b3 544 installmake misc-progs
33634aa8
MT
545 installmake e2fsprogs
546 installmake reiserfsprogs
a6316ce4 547 installmake sysfsutils
df5e82b3 548 installmake util-linux
df5e82b3 549 installmake pciutils
fcb5057d 550 installmake kudzu
df5e82b3 551 installmake installer
df5e82b3 552 installmake initrd
df5e82b3
MT
553}
554
555buildpackages() {
556 LOGFILE="$BASEDIR/log/_build.packages.log"
557 export LOGFILE
558 echo "... see detailed log in _build.*.log files" >> $LOGFILE
0fbb45e9 559
edd536b6 560 installmake strip
df5e82b3
MT
561
562 # Generating list of packages used
0fbb45e9 563 echo -n "Generating packages list from logs" | tee -a $LOGFILE
df5e82b3
MT
564 rm -f $BASEDIR/doc/packages-list
565 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
566 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
7471f6ab 567 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
df5e82b3
MT
568 fi
569 done
7471f6ab 570 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
0fbb45e9 571 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$' \
df5e82b3
MT
572 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
573 rm -f $BASEDIR/doc/packages-list
c9673262 574 # packages-list.txt is ready to be displayed for wiki page
0fbb45e9 575 beautify message DONE
df5e82b3 576
9607771a 577 # Create images for install
15679d9f 578 ipfiremake cdrom
33634aa8 579 ipfiremake pxe
fcb5057d 580 cp -f $LFS/install/images/{*.iso,*.tgz} $BASEDIR >> $LOGFILE 2>&1
c9673262 581
72d80898 582# ipfirepackages
e67a57fe
MT
583
584 # Cleanup
585 stdumount
586 rm -rf $BASEDIR/build/tmp/*
587
588 # Generating total list of files
fd0763dc 589 echo "Generating files list from logs" | tee -a $LOGFILE
e67a57fe
MT
590 rm -f $BASEDIR/log/FILES
591 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
592 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
593 echo "##" >>$BASEDIR/log/FILES
594 echo "## `basename $i`" >>$BASEDIR/log/FILES
595 echo "##" >>$BASEDIR/log/FILES
596 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
597 fi
598 done
913668ba 599 cd $BASEDIR/packages; ls -w1 *.ipfire | awk -F ".ipfire" '{ print $1 }' > $BASEDIR/packages/packages_list.txt
5e773594 600 echo -n "###EOF###" >> $BASEDIR/packages/packages_list.txt
e67a57fe
MT
601
602 cd $PWD
603
604}
605
606ipfirepackages() {
013a23e2
MT
607 if [ -d "$BASEDIR/packages" ]; then
608 for i in `ls $BASEDIR/packages`; do
609 touch $BASEDIR/build/install/packages/$i.empty
610 done
611 fi
f1baee3e 612# ipfiredist amavisd
78331e30 613 ipfiredist applejuice
5ac2da9f 614 ipfiredist asterisk
c7acba4a 615 ipfiredist clamav
483f59cd 616 ipfiredist cups
78331e30
MT
617 ipfiredist cyrusimap
618 ipfiredist fetchmail
d1b6aa72 619 ipfiredist ffmpeg
78331e30 620 ipfiredist gnump3d
7a98bae5 621 ipfiredist iptraf
0d0521b6 622 ipfiredist java
78331e30 623 ipfiredist lame
d1b6aa72 624 ipfiredist libmad
ae179f6e 625 ipfiredist libogg
ae179f6e 626 ipfiredist libvorbis
f0ca8c34 627 ipfiredist mailx
3ab910dd 628 ipfiredist mldonkey
d1b6aa72 629 ipfiredist mpeg2dec
2ae94d2d 630 ipfiredist nagios
f0ca8c34
MT
631 ipfiredist nfs
632 ipfiredist nmap
3e45cc09 633 ipfiredist ntop
27ac55bf 634 ipfiredist portmap
78331e30 635 ipfiredist postfix
371d9df0 636 ipfiredist procmail
90350ff3 637 ipfiredist samba
ae179f6e 638 ipfiredist sox
f0ca8c34 639 ipfiredist spamassassin
7a98bae5 640 ipfiredist subversion
d1b6aa72 641 ipfiredist videolan
f1baee3e 642 ipfiredist webcyradm
d1b6aa72 643 ipfiredist xvid
0145f271 644 ipfiredist yasuc
78331e30 645 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
d535503d 646 mv -f $LFS/install/packages/*.{ipfire,md5} $BASEDIR/packages >> $LOGFILE 2>&1
483f59cd 647 rm -rf $BASEDIR/build/install/packages/*
df5e82b3
MT
648}
649
650# See what we're supposed to do
651case "$1" in
652build)
9729e787 653 clear
df5e82b3 654 BUILDMACHINE=`uname -m`
712d859c 655 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
df5e82b3 656 #only restore on a clean disk
9b0ff0a0 657 if [ ! -f log/cleanup-toolchain-2-tools ]; then
df5e82b3 658 if [ ! -n "$PACKAGE" ]; then
15679d9f 659 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
df5e82b3
MT
660 prepareenv
661 buildtoolchain
662 else
663 PACKAGENAME=${PACKAGE%.tar.gz}
15679d9f 664 beautify build_stage "Packaged toolchain compilation"
df5e82b3
MT
665 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
666 tar zxf $PACKAGE
667 prepareenv
668 else
669 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
670 fi
671 fi
672 else
9729e787
MT
673 echo -n "Using installed toolchain" | tee -a $LOGFILE
674 beautify message SKIP
df5e82b3
MT
675 prepareenv
676 fi
5cfe86e6 677
7ab7a9b4 678 beautify build_start
0b59f25c 679 beautify build_stage "Building LFS"
df5e82b3 680 buildbase
15679d9f 681
0b59f25c 682 beautify build_stage "Building IPFire"
15679d9f 683 buildipfire
5cfe86e6
HS
684
685 # Setzen des IPFire Builds
8af06406 686 if [ "$FIREBUILD" ]; then
e57bc1fd 687 echo "$FIREBUILD" > $BASEDIR/build/var/ipfire/firebuild
5cfe86e6 688 else
e57bc1fd 689 echo "_(OvO)_" > $BASEDIR/build/var/ipfire/firebuild
5cfe86e6
HS
690 fi
691
0b59f25c 692 beautify build_stage "Building installer"
df5e82b3 693 buildinstaller
15679d9f 694
0b59f25c 695 beautify build_stage "Building packages"
df5e82b3 696 buildpackages
7ab7a9b4 697 beautify build_end
df5e82b3
MT
698 ;;
699shell)
700 # enter a shell inside LFS chroot
701 # may be used to changed kernel settings
702 prepareenv
703 entershell
704 ;;
705changelog)
d1dd6669 706 echo -n "Loading new Changelog from SVN: "
f9315063 707 svn log http://svn.ipfire.eu/svn/ipfire > doc/ChangeLog
a50d04ab 708 beautify message DONE
df5e82b3 709 ;;
df5e82b3 710clean)
a50d04ab 711 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
df5e82b3
MT
712 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
713 $LOSETUP -d $i 2>/dev/null
714 done
715 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
716 umount $i
717 done
718 stdumount
719 for i in `seq 0 7`; do
720 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
721 umount /dev/loop${i} 2>/dev/null;
722 losetup -d /dev/loop${i} 2>/dev/null;
723 fi;
724 done
725 rm -rf $BASEDIR/build
726 rm -rf $BASEDIR/cdrom
f9315063 727 rm -rf $BASEDIR/packages
df5e82b3 728 rm -rf $BASEDIR/log
df5e82b3
MT
729 if [ -h /tools ]; then
730 rm -f /tools
731 fi
a50d04ab 732 beautify message DONE
df5e82b3 733 ;;
c3db995c 734downloadsrc)
df5e82b3
MT
735 if [ ! -d $BASEDIR/cache ]; then
736 mkdir $BASEDIR/cache
737 fi
738 mkdir -p $BASEDIR/log
857d9bf2 739 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
df5e82b3
MT
740 FINISHED=0
741 cd $BASEDIR/lfs
742 for c in `seq $MAX_RETRIES`; do
743 if (( FINISHED==1 )); then
744 break
745 fi
746 FINISHED=1
747 cd $BASEDIR/lfs
748 for i in *; do
749 if [ -f "$i" -a "$i" != "Config" ]; then
e22c7973 750 echo -ne "Loading $i"
df5e82b3
MT
751 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
752 if [ $? -ne 0 ]; then
e22c7973 753 beautify message FAIL
df5e82b3
MT
754 FINISHED=0
755 else
756 if [ $c -eq 1 ]; then
e22c7973 757 beautify message DONE
df5e82b3
MT
758 fi
759 fi
760 fi
761 done
762 done
e22c7973 763 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
df5e82b3
MT
764 ERROR=0
765 for i in *; do
766 if [ -f "$i" -a "$i" != "Config" ]; then
767 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
768 if [ $? -ne 0 ]; then
e22c7973
MT
769 echo -ne "MD5 difference in lfs/$i"
770 beautify message FAIL
df5e82b3
MT
771 ERROR=1
772 fi
773 fi
774 done
775 if [ $ERROR -eq 0 ]; then
e22c7973
MT
776 echo -ne "${BOLD}all files md5sum match${NORMAL}"
777 beautify message DONE
778 else
779 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
780 beautify message FAIL
df5e82b3 781 fi
e22c7973 782 cd - >/dev/null 2>&1
df5e82b3 783 ;;
df5e82b3 784toolchain)
9729e787 785 clear
df5e82b3 786 prepareenv
15679d9f 787 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
df5e82b3
MT
788 buildtoolchain
789 BUILDMACHINE=`uname -m`
790 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
712d859c
MT
791 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
792 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
df5e82b3
MT
793 build/{bin,etc,usr/bin,usr/local} \
794 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
795 log >> $LOGFILE
712d859c
MT
796 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
797 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
df5e82b3
MT
798 stdumount
799 ;;
800gettoolchain)
801 BUILDMACHINE=`uname -m`
802 # arbitrary name to be updated in case of new toolchain package upload
c6cb9d25 803 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
712d859c 804 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
5bd13f01 805 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
712d859c
MT
806 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
807 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
808 cd $BASEDIR/cache/toolchains
5bd13f01 809 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
712d859c
MT
810 if [ $? -ne 0 ]; then
811 echo "`date -u '+%b %e %T'`: error downloading toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
40a4ea4c 812 else
712d859c
MT
813 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
814 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
815 else
816 exiterror "$PACKAGE.md5 did not match, check downloaded package"
817 fi
40a4ea4c 818 fi
712d859c
MT
819 else
820 echo "Toolchain is already downloaded. Exiting..."
df5e82b3
MT
821 fi
822 ;;
15679d9f 823othersrc)
ce56e927 824 prepareenv
15679d9f 825 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
ce56e927
MT
826 chroot $LFS /tools/bin/env -i HOME=/root \
827 TERM=$TERM PS1='\u:\w\$ ' \
828 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
829 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
830 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
831 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
15679d9f
MT
832 if [ $? -eq "0" ]; then
833 beautify message DONE
834 else
835 beautify message FAIL
836 fi
ce56e927
MT
837 stdumount
838 ;;
c6cb9d25
MT
839svn)
840 case "$2" in
841 update|up)
cc0e56be 842 # clear
15679d9f 843 echo -ne "Loading the latest source files...\n"
7471f6ab
MT
844 if [ $3 ]; then
845 svn update -r $3 | tee -a $PWD/log/_build.svn.update.log
846 else
847 svn update | tee -a $PWD/log/_build.svn.update.log
848 fi
15679d9f
MT
849 if [ $? -eq "0" ]; then
850 beautify message DONE
c6cb9d25 851 else
15679d9f 852 beautify message FAIL
c6cb9d25
MT
853 exit 1
854 fi
15679d9f 855 echo -ne "Writing the svn-info to a file"
c6cb9d25 856 svn info > $PWD/svn_status
15679d9f
MT
857 if [ $? -eq "0" ]; then
858 beautify message DONE
c6cb9d25 859 else
15679d9f 860 beautify message FAIL
c6cb9d25
MT
861 exit 1
862 fi
712d859c 863 chmod 755 $0
cc0e56be 864 exit 0
c6cb9d25
MT
865 ;;
866 commit|ci)
867 clear
6b8cff41
MT
868 if [ -f /usr/bin/mcedit ]; then
869 export EDITOR=/usr/bin/mcedit
73d9a908
MT
870 fi
871 if [ -f /usr/bin/nano ]; then
872 export EDITOR=/usr/bin/nano
6b8cff41
MT
873 fi
874 echo -ne "Selecting editor $EDITOR..."
875 beautify message DONE
d79b46cb 876 if [ -e /sbin/yast ]; then
028698e8
MT
877 if [ "`echo $SVN_REVISION | cut -c 3`" -eq "0" ]; then
878 $0 changelog
879 fi
d79b46cb 880 fi
15679d9f 881 svn commit
c6cb9d25 882 $0 svn up
6b8cff41 883 $0 uploadsrc
c6cb9d25
MT
884 ;;
885 dist)
7471f6ab
MT
886 if [ $3 ]; then
887 SVN_REVISION=$3
888 fi
889 if [ -f ipfire-source-r$SVN_REVISION.tar.gz ]; then
890 echo -ne "REV $SVN_REVISION: SKIPPED!\n"
891 exit 0
892 fi
893 echo -en "REV $SVN_REVISION: Downloading..."
9729e787
MT
894 svn export http://svn.ipfire.eu/svn/ipfire/trunk ipfire-source/ --force > /dev/null
895 svn log http://svn.ipfire.eu/svn/ipfire/trunk -r 1:$SVN_REVISION > ipfire-source/Changelog
896 #svn info http://svn.ipfire.eu/svn/ipfire/trunk -r $SVN_REVISION > ipfire-source/svn_status
15679d9f
MT
897 evaluate 1
898
7471f6ab
MT
899 echo -en "REV $SVN_REVISION: Compressing files..."
900 if [ -e ipfire-source/trunk/make.sh ]; then
901 chmod 755 ipfire-source/trunk/make.sh
902 fi
9dc02b38 903 tar cfz ipfire-source-r$SVN_REVISION.tar.gz ipfire-source
15679d9f 904 evaluate 1
7471f6ab 905 echo -en "REV $SVN_REVISION: Cleaning up..."
c6cb9d25 906 rm ipfire-source/ -r
15679d9f 907 evaluate 1
7471f6ab 908 ;;
028698e8 909 diff|di)
15679d9f 910 echo -ne "Make a local diff to last svn revision"
c6cb9d25 911 svn diff > ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff
15679d9f 912 evaluate 1
c6cb9d25
MT
913 echo "Diff was successfully saved to ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff"
914 ;;
915 esac
f9315063 916 ;;
15679d9f
MT
917uploadsrc)
918 PWD=`pwd`
919 cd $BASEDIR/cache/
920 echo -e "Uploading cache to ftp server:"
71e32384 921 ncftpls -u $FTP_CACHE_USER -p $FTP_CACHE_PASS ftp://$FTP_CACHE_URL$FTP_CACHE_PATH/ > /var/tmp/ftplist
15679d9f 922 for i in *; do
f59e1e88 923 if [ "$i" == "toolchains" ]; then continue; fi
15679d9f 924 grep -q $i /var/tmp/ftplist
0eab8e84 925 if [ "$?" -ne "0" ]; then
15679d9f 926 echo -ne "$i"
71e32384 927 ncftpput -u $FTP_CACHE_USER -p $FTP_CACHE_PASS $FTP_CACHE_URL $FTP_CACHE_PATH/ $i
0eab8e84 928 if [ "$?" -eq "0" ]; then
15679d9f 929 beautify message DONE
0eab8e84 930 else
15679d9f 931 beautify message FAIL
0eab8e84
MT
932 fi
933 fi
934 done
15679d9f 935 rm -f /var/tmp/ftplist
15679d9f
MT
936 cd $PWD
937 exit 0
0eab8e84 938 ;;
cc0e56be
MT
939upload)
940 case "$2" in
941 iso)
942 echo -e "Uploading the iso to $IPFIRE_FTP_URL_EXT."
9dc02b38
MT
943 cat <<EOF > .ftp-commands
944mkdir $IPFIRE_FTP_PATH_EXT
945ls -lah
946quit
947EOF
948 ncftp -u $IPFIRE_FTP_USER_EXT -p $IPFIRE_FTP_PASS_EXT $IPFIRE_FTP_URL_EXT < .ftp-commands
949 rm -f .ftp-commands
950 md5sum ipfire-install-$VERSION.i386.iso > ipfire-install-$VERSION.i386.iso.md5
71e32384
MT
951 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/ ipfire-install-$VERSION.i386.iso
952 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/ ipfire-install-$VERSION.i386.iso.md5
953 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/ ipfire-source-r$SVN_REVISION.tar.gz
954 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/ svn_status
9dc02b38
MT
955 if [ "$?" -eq "0" ]; then
956 echo -e "The iso of Revision $SVN_REVISION was successfully uploaded to $IPFIRE_FTP_URL_EXT$IPFIRE_FTP_PATH_EXT/."
cc0e56be 957 else
9dc02b38
MT
958 echo -e "There was an error while uploading the iso to the ftp server."
959 exit 1
cc0e56be 960 fi
6aae8d61 961 if [ "$3" = "--with-sources-cd" ]; then
71e32384 962 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/ ipfire-sources-cd-$VERSION.$MACHINE.iso
6aae8d61 963 fi
cc0e56be
MT
964 ;;
965 paks)
9dc02b38
MT
966 cat <<EOF > .ftp-commands
967mkdir $IPFIRE_FTP_PATH_PAK
968ls -lah
969quit
970EOF
971 ncftp -u $IPFIRE_FTP_USER_PAK -p $IPFIRE_FTP_PASS_PAK $IPFIRE_FTP_URL_PAK < .ftp-commands
972 rm -f .ftp-commands
cc0e56be
MT
973 ncftpput -z -u $IPFIRE_FTP_USER_PAK -p $IPFIRE_FTP_PASS_PAK $IPFIRE_FTP_URL_PAK $IPFIRE_FTP_PATH_PAK/ packages/*
974 if [ "$?" -eq "0" ]; then
9dc02b38 975 echo -e "The packages were successfully uploaded to $IPFIRE_FTP_URL_PAK$IPFIRE_FTP_PATH_PAK/."
cc0e56be
MT
976 else
977 echo -e "There was an error while uploading the packages to the ftp server."
712d859c 978 exit 1
cc0e56be
MT
979 fi
980 ;;
981 esac
0d0521b6 982 ;;
cc0e56be 983batch)
15679d9f
MT
984 if [ "$2" -eq "--background" ]; then
985 batch_script
986 exit $?
987 fi
27ac55bf 988 if [ `screen -ls | grep -q ipfire` ]; then
712d859c
MT
989 echo "Build is already running, sorry!"
990 exit 1
991 else
27ac55bf
MT
992 if [ "$2" = "--rebuild" ]; then
993 export IPFIRE_REBUILD=1
994 echo "REBUILD!"
995 else
996 export IPFIRE_REBUILD=0
997 fi
15679d9f
MT
998 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
999 screen -dmS ipfire $0 batch --background
1000 evaluate 1
712d859c
MT
1001 exit 0
1002 fi
cc0e56be 1003 ;;
028698e8 1004watch)
15679d9f 1005 watch_screen
028698e8 1006 ;;
33634aa8
MT
1007pxe)
1008 case "$2" in
1009 start)
1010 start_tftpd
1011 ;;
1012 stop)
1013 stop_tftpd
1014 ;;
a50d04ab 1015 reload|restart)
33634aa8
MT
1016 reload_tftpd
1017 ;;
1018 esac
1019 exit 0
1020 ;;
6b8cff41 1021"")
24a4a744
MT
1022 clear
1023 svn info
c3db995c 1024 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "SVN: Commit" "SVN: Update" "SVN: Status" "SVN: Diff" "LOG: Tail" "Help"
24a4a744
MT
1025 do
1026 case $name in
c3db995c
MT
1027 "IPFIRE: Downloadsrc")
1028 $0 downloadsrc
c6cb9d25
MT
1029 ;;
1030 "IPFIRE: Build (silent)")
1031 $0 build-silent
1032 ;;
1033 "IPFIRE: Watch Build")
028698e8 1034 $0 watch
c6cb9d25 1035 ;;
712d859c
MT
1036 "IPFIRE: Batch")
1037 $0 batch
1038 ;;
c6cb9d25
MT
1039 "IPFIRE: Clean")
1040 $0 clean
1041 ;;
c6cb9d25
MT
1042 "SVN: Update")
1043 $0 svn update
1044 ;;
c6cb9d25 1045 "Help")
a50d04ab 1046 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
c6cb9d25
MT
1047 cat doc/make.sh-usage
1048 ;;
712d859c
MT
1049 "LOG: Tail")
1050 tail -f log/_*
1051 ;;
c6cb9d25
MT
1052 "Exit")
1053 break
1054 ;;
24a4a744
MT
1055 esac
1056 done
df5e82b3 1057 ;;
a50d04ab
MT
1058config)
1059 make_config
1060 ;;
6b8cff41 1061*)
a50d04ab 1062 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
6b8cff41
MT
1063 cat doc/make.sh-usage
1064 ;;
3ea75603 1065esac